"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("core-js/modules/es6.object.define-property");

require("core-js/modules/es6.object.define-properties");

require("core-js/modules/es7.object.get-own-property-descriptors");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es6.date.to-string");

require("core-js/modules/es6.reflect.construct");

require("core-js/modules/es6.promise");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.array.for-each");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("core-js/modules/es6.regexp.match");

require("core-js/modules/es6.array.map");

require("core-js/modules/es6.array.filter");

require("core-js/modules/es6.regexp.search");

require("regenerator-runtime/runtime");

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = require("react");

var _reactRouterConfig = require("react-router-config");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _qs = require("qs");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

/**
 * 网站入口组件
 * 服务器端和浏览器端渲染都会调用
 */
var App = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(App, _Component);

  var _super = _createSuper(App);

  function App(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, App);
    _this = _super.call(this, props);
    _this.state = {
      initialProps: props.initialProps
    };
    return _this;
  }

  (0, _createClass2["default"])(App, [{
    key: "componentWillReceiveProps",
    value: function () {
      var _componentWillReceiveProps = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(nextProps
      /* , nextState */
      ) {
        var navigated, query, promises, initialProps;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                navigated = nextProps.location.pathname !== this.props.location.pathname;

                if (!navigated) {
                  _context2.next = 16;
                  break;
                }

                // 浏览器端路由（首次渲染后）时解析 querystring -> object
                query = (0, _qs.parse)(nextProps.location.search, {
                  ignoreQueryPrefix: true
                });
                nextProps.location.query = query;
                promises = (0, _reactRouterConfig.matchRoutes)(this.props.routes, nextProps.location.pathname).map( /*#__PURE__*/function () {
                  var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(_ref) {
                    var route, match, component, ctx, getInitialProps;
                    return _regenerator["default"].wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            route = _ref.route, match = _ref.match;
                            component = route.component;

                            if (!component) {
                              _context.next = 10;
                              break;
                            }

                            if (!(component.load && !component.loadingPromise)) {
                              _context.next = 6;
                              break;
                            }

                            _context.next = 6;
                            return component.load();

                          case 6:
                            if (!component.getInitialProps) {
                              _context.next = 10;
                              break;
                            }

                            ctx = {
                              match: match,
                              query: query
                            };
                            getInitialProps = component.getInitialProps;
                            return _context.abrupt("return", getInitialProps ? getInitialProps(ctx) : null);

                          case 10:
                            return _context.abrupt("return", null);

                          case 11:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee);
                  }));

                  return function (_x2) {
                    return _ref2.apply(this, arguments);
                  };
                }()).filter(Boolean);
                _context2.prev = 5;
                initialProps = {};
                _context2.next = 9;
                return Promise.all(promises);

              case 9:
                _context2.sent.forEach(function (item) {
                  initialProps = _objectSpread(_objectSpread({}, initialProps), item);
                });

                this.setState({
                  initialProps: initialProps
                });
                _context2.next = 16;
                break;

              case 13:
                _context2.prev = 13;
                _context2.t0 = _context2["catch"](5);
                console.log('getInitialProps error: ', _context2.t0);

              case 16:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this, [[5, 13]]);
      }));

      function componentWillReceiveProps(_x) {
        return _componentWillReceiveProps.apply(this, arguments);
      }

      return componentWillReceiveProps;
    }()
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (process.env.DACE_SCROLL_TO_TOP === 'true' && this.props.location !== prevProps.location) {
        window.scrollTo(0, 0);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var initialProps = this.state.initialProps;
      var _this$props = this.props,
          route = _this$props.route,
          location = _this$props.location; // 让 children 能通过 props.location.query 能取到 query string
      // App 组件首次渲染时执行

      location.query = (0, _qs.parse)(location.search, {
        ignoreQueryPrefix: true
      });
      return (0, _reactRouterConfig.renderRoutes)(route.routes, initialProps);
    }
  }]);
  return App;
}(_react.Component);

exports["default"] = App;
(0, _defineProperty2["default"])(App, "propTypes", {
  routes: _propTypes["default"].any,
  route: _propTypes["default"].object.isRequired,
  location: _propTypes["default"].object.isRequired,
  initialProps: _propTypes["default"].any
});
(0, _defineProperty2["default"])(App, "defaultProps", {
  initialProps: {},
  routes: []
});
module.exports = exports.default;