"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("core-js/modules/es6.object.define-property");

require("core-js/modules/es6.object.define-properties");

require("core-js/modules/es7.object.get-own-property-descriptors");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.keys");

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

require("core-js/modules/es6.promise");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.array.for-each");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("core-js/modules/es6.regexp.match");

require("core-js/modules/es6.array.map");

require("core-js/modules/es6.array.filter");

require("core-js/modules/es6.function.name");

require("regenerator-runtime/runtime");

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _react = _interopRequireDefault(require("react"));

var _reactRouterDom = require("react-router-dom");

var _reactRouterConfig = require("react-router-config");

var _server = require("react-dom/server");

var _server2 = require("@loadable/server");

var _reactHelmet = require("react-helmet");

var _serializeJavascript = _interopRequireDefault(require("serialize-javascript"));

var _redboxReact = require("redbox-react");

var _NotFound = _interopRequireDefault(require("./components/NotFound"));

var _document = _interopRequireDefault(require("./document"));

var _ssrRoutes = _interopRequireDefault(require("./ssrRoutes"));

var _jsxFileName = "/Users/zhi.zhong/workspace/github/dacejs/dace/src/runtime/ssrMiddleware.js";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var _default = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(req, res) {
    var query, pathname, ssr, branch, notFound, html, initialProps, promises, context, Markup, stats, extractor, jsx, markup, scriptTags, styleTags, head, state, _html;

    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            // 查找当前 URL 匹配的路由
            query = req.query, pathname = req._parsedUrl.pathname;
            ssr = process.env.DACE_SSR === 'true';
            branch = (0, _reactRouterConfig.matchRoutes)(_ssrRoutes["default"], pathname); // 匹配的最后一个组件是 `NotFound` 的话，表示地址不存在

            notFound = branch[branch.length - 1].route.component.name === 'NotFound';

            if (!notFound) {
              _context2.next = 8;
              break;
            }

            // 只有网页类请求才走自定义404页面
            if (/html/.test(req.get('accept'))) {
              html = (0, _document["default"])({
                markup: (0, _server.renderToString)(_react["default"].createElement(_NotFound["default"], {
                  location: {
                    pathname: pathname
                  },
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 25
                  }
                }))
              });
              res.status(200).end(html);
            } else {
              // 非网页类请求直接返回404
              res.status(404).end();
            }

            _context2.next = 25;
            break;

          case 8:
            initialProps = {};

            if (!ssr) {
              _context2.next = 15;
              break;
            }

            promises = branch // <- react-router 不匹配 querystring
            .map( /*#__PURE__*/function () {
              var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(_ref2) {
                var route, match, component, AsyncComponent, ctx, props;
                return _regenerator["default"].wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        route = _ref2.route, match = _ref2.match;
                        component = route.component;

                        if (!(component && component.load && typeof component.load === 'function')) {
                          _context.next = 12;
                          break;
                        }

                        _context.next = 5;
                        return component.load();

                      case 5:
                        AsyncComponent = _context.sent["default"];

                        if (!AsyncComponent.getInitialProps) {
                          _context.next = 12;
                          break;
                        }

                        ctx = {
                          match: match,
                          query: query,
                          req: req,
                          res: res
                        };
                        _context.next = 10;
                        return AsyncComponent.getInitialProps(ctx);

                      case 10:
                        props = _context.sent;
                        return _context.abrupt("return", props);

                      case 12:
                        return _context.abrupt("return", null);

                      case 13:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function (_x3) {
                return _ref3.apply(this, arguments);
              };
            }()).filter(Boolean);

            if (!(promises.length > 0)) {
              _context2.next = 15;
              break;
            }

            _context2.next = 14;
            return Promise.all(promises);

          case 14:
            _context2.sent.forEach(function (item) {
              initialProps = _objectSpread(_objectSpread({}, initialProps), item);
            });

          case 15:
            context = {};
            Markup = ssr ? _react["default"].createElement(_reactRouterDom.StaticRouter, {
              context: context,
              location: req.url,
              __source: {
                fileName: _jsxFileName,
                lineNumber: 63
              }
            }, (0, _reactRouterConfig.renderRoutes)(_ssrRoutes["default"], {
              initialProps: initialProps
            })) : null; // This is the stats file generated by webpack loadable plugin

            stats = require(process.env.DACE_PATH_LOADABLE_STATS_JSON); // We create an extractor from the statsFile

            extractor = new _server2.ChunkExtractor({
              stats: stats
            }); // Wrap your application using "collectChunks"

            jsx = extractor.collectChunks(Markup);

            try {
              markup = (0, _server.renderToString)(jsx);
              scriptTags = extractor.getScriptTags();
              styleTags = extractor.getStyleTags();
            } catch (error) {
              res.status(500);
              markup = (0, _server.renderToString)(_react["default"].createElement(_redboxReact.RedBoxError, {
                error: error,
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 84
                }
              }));
            } // renderStatic 需要在 root 元素 renderToString 后执行


            head = _reactHelmet.Helmet.renderStatic();
            state = (0, _serializeJavascript["default"])(initialProps);
            _html = (0, _document["default"])({
              head: head,
              markup: markup,
              state: state,
              styleTags: styleTags,
              scriptTags: scriptTags
            });
            res.status(200).end(_html);

          case 25:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

exports["default"] = _default;
module.exports = exports.default;