"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("core-js/modules/es6.array.for-each");

var _chalk = _interopRequireDefault(require("chalk"));

/**
 * Print an array of errors to console.
 *
 * @param {string} summary Summary of error
 * @param {Array<Error>} errors Array of Errors
 */
var _default = function _default(summary, errors) {
  console.log(_chalk["default"].red(summary));
  console.log();
  errors.forEach(function (err) {
    console.log(err.message || err);
    console.log();
  });
};

exports["default"] = _default;
module.exports = exports.default;